// e544e925-dc72-4713-8497-7f8f6272a47b

function NeutrinoEffect(ctx) {

	var Db = this;

	var ne = function (Ld, Bd) {
		this.Ld = Ld;
		this.Bd = Bd;

		if (this.Bd.we.pe.length > 0) {
			this.we = this.Bd.we.pe[0];

			this.Lc = [ne.prototype.Ec,
				ne.prototype.Fc][this.we.xe];
		}
		else
			this.we = null;
	}

	ne.prototype = {
		Ec: function (fe, Ab, Xb) {
			var Gc = ctx.ib(Xb.Md);
			var Hc = Math.cos(Gc);
			var Ic = Math.sin(Gc);
			var ye = ctx.Ae(Xb.Nd[0]);
			var ze = ctx.Ae(Xb.Nd[1]);
			fe./**/transform(ye * Hc, ye * Ic, ze * -Ic, ze * Hc, Ab[0], Ab[1]);
		},

		Fc: function (fe, Ab, Xb) {
			var q = Xb.Mc;
			var z2 = 2.0 * q[2] * q[2];
			var xy = 2.0 * q[0] * q[1];
			var wz = 2.0 * q[3] * q[2];
			var ye = ctx.Ae(Xb.Nd[0]);
			var ze = ctx.Ae(Xb.Nd[1]);
			fe./**/transform(
				ye * (1.0 - 2.0 * q[1] * q[1] - z2),
				ye * (xy + wz),
				ze * (wz - xy),
				ze * (2.0 * q[0] * q[0] + z2 - 1.0),
				Ab[0], Ab[1]);
		},

		Pc: function (fe, Xb, ge) {
			Xb.vc(fe, -1, ge);

			if (this.we) {

				if (this.Be != null && !Xb.oc) {

					if (Xb.Od > 0.001) {
						var De = Math.floor(Xb.Qc % this.we.Rc);
						var Ee = Math.floor(Xb.Qc / this.we.Rc);

						var Ab = Xb.Ab.slice();
						var Nd = Xb.Nd.slice();
						if (!ge || ge./**/transform(Ab, Nd)) {

							var df = Math.abs(Nd[0]);
							var ef = Math.abs(Nd[1]);

							if (df > 0.001 && ef > 0.001) {
								fe.save();
								this.Lc(fe, Ab, Xb);

								fe.translate(-df * Xb.Pd[0], -ef * (1 - Xb.Pd[1]));
								fe.globalAlpha = Xb.Od;

								if (Xb.gf[0] < 0.999 || Xb.gf[1] < 0.999 || Xb.gf[2] < 0.999) {

									var Ye = df < this.Tc ? df : this.Tc;
									var Ze = ef < this.Uc ? ef : this.Uc;

									ctx.af(Ye, Ze);

									ctx.bf.globalCompositeOperation = "copy";
									ctx.bf.drawImage(this.Be.image,
										this.Be.x + this.Tc * De, this.Be.y + this.Uc * Ee,
										this.Tc, this.Uc,
										0, 0, Ye, Ze);

									ctx.bf.globalCompositeOperation = "multiply";
									ctx.bf.fillStyle = ctx.ff(Xb.gf);
									ctx.bf.fillRect(0, 0, Ye, Ze);

									ctx.bf.globalCompositeOperation = "destination-atop";
									ctx.bf.drawImage(this.Be.image,
										this.Be.x + this.Tc * De, this.Be.y + this.Uc * Ee,
										this.Tc, this.Uc,
										0, 0, Ye, Ze);

									fe.drawImage(ctx.cf, 0, 0, Ye, Ze, 0, 0, df, ef);
								}
								else {
									fe.drawImage(this.Be.image,
										this.Be.x + this.Tc * De, this.Be.y + this.Uc * Ee,
										this.Tc, this.Uc, 0, 0, df, ef);
								}

								fe.restore();
							}
						}
					}
				}
			}

			Xb.vc(fe, 1, ge);
		},

		Hd: function (fe, ge) {
			fe.save();

			if (this.we) {
				fe.globalCompositeOperation = this.Ld.materials[this.Ld./**/model.renderStyles[this.we.renderStyleIndex].materialIndex];
				this.Be = this.Ld.textureDescs[this.Ld./**/model.renderStyles[this.we.renderStyleIndex].textureIndices[0]];
			}
			else {
				this.Be = null;
			}

			if (this.Be) {
				this.Tc = this.Be.width / this.we.Rc;
				this.Uc = this.Be.height / this.we.Sc;
			}

			function kd(a, b) {
				if (a.Ab[2] < b.Ab[2])
					return 1;
				if (a.Ab[2] > b.Ab[2])
					return -1;
				return 0;
			}

			switch (this.Bd.Vc) {
				case 0:
					for (var Wb = 0; Wb < this.Bd.tc.length; ++Wb) {
						this.Pc(fe, this.Bd.tc[Wb], ge);
					}
					break;
				case 1:
					for (var Wb = this.Bd.tc.length; Wb-- > 0;) {
						this.Pc(fe, this.Bd.tc[Wb], ge);
					}
					break;
				case 2:
					this.Bd.tc.sort(kd);

					for (var Wb = 0; Wb < this.Bd.tc.length; ++Wb) {
						this.Pc(fe, this.Bd.tc[Wb], ge);
					}
					break;
			}

			fe.restore();
		}
	}

	var oe = function (Ld, Bd) {

		this.Ld = Ld;
		this.Bd = Bd;

		if (this.Bd.we.pe.length > 0)
			this.we = this.Bd.we.pe[0];
		else
			this.we = null;

		this.vertex = [
			{ /**/position: [0.0, 0.0, 0.0], /**/color: [0, 0, 0, 0], /**/texCoords: [[0.0, 0.0]] },
			{ /**/position: [0.0, 0.0, 0.0], /**/color: [0, 0, 0, 0], /**/texCoords: [[0.0, 0.0]] },
			{ /**/position: [0.0, 0.0, 0.0], /**/color: [0, 0, 0, 0], /**/texCoords: [[0.0, 0.0]] },
			{ /**/position: [0.0, 0.0, 0.0], /**/color: [0, 0, 0, 0], /**/texCoords: [[0.0, 0.0]] }];
	}

	oe.prototype = {
		qe: function (Xb, se, re, te, renderBuffer) {
			Xb.Ce(-1, se, re, te, renderBuffer);

			if (this.we) {

				if (!Xb.oc) {

					var v0 = this.vertex[0];
					var v1 = this.vertex[1];
					var v2 = this.vertex[2];
					var v3 = this.vertex[3];

					var Fe = [], Ge = [];

					if (this.we.xe == 0) {
						var a = ctx.ib(Xb.Md);
						var s = Math.sin(a);
						var c = Math.cos(a);

						Fe[0] = se[0] * c + re[0] * s;
						Fe[1] = se[1] * c + re[1] * s;
						Fe[2] = se[2] * c + re[2] * s;

						Ge[0] = -se[0] * s + re[0] * c;
						Ge[1] = -se[1] * s + re[1] * c;
						Ge[2] = -se[2] * s + re[2] * c;
					}
					else {
						var q = Xb.Mc;
						var z2 = 2.0 * q[2] * q[2];
						var xy = 2.0 * q[0] * q[1];
						var wz = 2.0 * q[3] * q[2];

						Fe[0] = 1.0 - 2.0 * q[1] * q[1] - z2;
						Fe[1] = xy + wz;
						Fe[2] = 2.0 * q[0] * q[2] - 2.0 * q[3] * q[1];

						Ge[0] = xy - wz;
						Ge[1] = 1.0 - 2.0 * q[0] * q[0] - z2;
						Ge[2] = 2.0 * q[1] * q[2] + 2.0 * q[3] * q[0];
					}

					var He = [], Ie = [], Je = [], Ke = [];
					ctx.u(He, Fe, -Xb.Nd[0] * Xb.Pd[0]);
					ctx.u(Ie, Fe, Xb.Nd[0] * (1.0 - Xb.Pd[0]));
					ctx.u(Je, Ge, -Xb.Nd[1] * Xb.Pd[1]);
					ctx.u(Ke, Ge, Xb.Nd[1] * (1.0 - Xb.Pd[1]));

					ctx.c(v0./**/position, He, Je);
					ctx.c(v0./**/position, v0./**/position, Xb.Ab);
					ctx.c(v1./**/position, He, Ke);
					ctx.c(v1./**/position, v1./**/position, Xb.Ab);
					ctx.c(v2./**/position, Ie, Ke);
					ctx.c(v2./**/position, v2./**/position, Xb.Ab);
					ctx.c(v3./**/position, Ie, Je);
					ctx.c(v3./**/position, v3./**/position, Xb.Ab);

					{
						var rgb = ctx.v(Xb.gf, 255);
						v0./**/color = v1./**/color = v2./**/color = v3./**/color = [rgb[0], rgb[1], rgb[2], Xb.Od * 255];
					}

					{
						var De = Math.floor(Xb.Qc % this.we.Rc);
						var Ee = Math.floor(Xb.Qc / this.we.Rc);

						var Pe, Qe, Re, Se;

						var We = this.Ld.texturesRemap[this.Ld./**/model.renderStyles[this.we.renderStyleIndex].textureIndices[0]];
						if (We) {
							var Ue = We.width / this.we.Rc;
							var Ve = We.height / this.we.Sc;

							var Pe = We.x + De * Ue;
							var Qe = Pe + Ue;
							var Re = (We.y + We.height - Ee * Ve);
							var Se = Re - Ve;
						} else {
							var Ue = 1.0 / this.we.Rc;
							var Ve = 1.0 / this.we.Sc;

							var Pe = De * Ue;
							var Qe = Pe + Ue;
							var Re = (1.0 - Ee * Ve);
							var Se = Re - Ve;
						}

						v0./**/texCoords[0] = [Pe, Se];
						v1./**/texCoords[0] = [Pe, Re];
						v2./**/texCoords[0] = [Qe, Re];
						v3./**/texCoords[0] = [Qe, Se];
					}

					renderBuffer.pushVertex(v0);
					renderBuffer.pushVertex(v1);
					renderBuffer.pushVertex(v2);
					renderBuffer.pushVertex(v3);

					if (!renderBuffer.__lastRenderCall) {
						renderBuffer.__lastRenderCall = new ctx.RenderCall(0, 6, this.we.renderStyleIndex);
					} else {
						var lastRenderCall = renderBuffer.__lastRenderCall;

						if (lastRenderCall.renderStyleIndex == this.we.renderStyleIndex) {
							lastRenderCall.numIndices += 6;
						} else {
							renderBuffer.pushRenderCall(lastRenderCall);
							renderBuffer.__lastRenderCall = new ctx.RenderCall(
								lastRenderCall.startIndex + lastRenderCall.numIndices,
								6, this.we.renderStyleIndex);
						}
					}
				}
			}

			Xb.Ce(1, se, re, te, renderBuffer);
		},

		ue: function (se, re, te, renderBuffer) {
			switch (this.Bd.Vc) {
				case 0:
					for (var Wb = 0; Wb < this.Bd.tc.length; ++Wb) {
						this.qe(this.Bd.tc[Wb], se, re, te, renderBuffer);
					}
					break;

				case 1:
					for (var Wb = this.Bd.tc.length; Wb-- > 0;) {
						this.qe(this.Bd.tc[Wb], se, re, te, renderBuffer);
					}
					break;

				case 2:
					this.Bd.tc.forEach(function (Xb) {
						Xb.depth = ctx.H(te, Xb.Ab);
					});

					this.Bd.tc.sort(function (a, b) {
						if (a.depth < b.depth)
							return 1;
						if (a.depth > b.depth)
							return -1;
						return 0;
					});

					this.Bd.tc.forEach(function (Xb) {
						this.qe(Xb, se, re, te, renderBuffer);
					}, this);
					break;
			}
		}
	}

	var ld = function (Ld, we, ve) {
		var Vb = this;
		this.Ld = Ld;
		this.we = we;

		// Eb

		function Eb() {
			this.Fb = 0;
			this.Gb = 1;
			this.Hb = null;
			this.Ib = null;
			this.Kb = 0;
			this.Lb = 1;

			Vb.we.Mb(this); // IMPL

			this.Nb = function () {
				this.Ob = this.Gb;
				this.Fb = 0;
			}

			this.Nb();
		}

		Eb.prototype = {
			Jd: function () {
				this.Nb();
			},

			Id: function (Qb, Ab, Mc) {
				Vb.we.Pb(Qb, Vb, this); // IMPL

				var Rb = Vb.Rb;
				var systemTime = Ld.Rb;
				var Sb = Qb;
				var ic = 0;

				if (this.zb > 0.000001) {

					var Tb = this.Ob + Qb * this.zb;

					while (Tb >= 1.0) {
						var Ub = this.zb < 0.001 ? 0.0 : (1.0 - this.Ob) / this.zb;
						Sb -= Ub;
						Rb += Ub;
						systemTime += Ub;

						if (this.Hb != null && Rb > this.Hb) {
							Vb.disactivate();
							break;
						}

						Vb.Rb = Rb;
						Ld.Rb = systemTime;

						if (Ab && Qb > 0)
							ctx.ab(Vb.Ab, Ab, Vb.Bb, Sb / Qb);

						if (Mc && Qb > 0)
							ctx.slerpq(Vb.Mc, Mc, Vb.prevRotation, Sb / Qb);

						// for the future when Jb would be external
						this.Lb = this.Jb;

						for (var Wb = 0; Wb < this.Jb; ++Wb) {
							if (Vb.sc.length == 0)
								break;

							if (this.Jb == 1)
								this.Kb = 0;
							else
								this.Kb = Wb / (this.Jb - 1);

							var Xb = Vb.sc.pop();
							Vb.tc.unshift(Xb);

							if (Wb == 0)
								Xb.Yb();
							else
								Xb.Zb();

							Xb.Id(Sb);
							++ic;
						}

						this.Ob = 0.0;
						Tb -= 1.0;

						if (this.Ib != null && ++this.Fb >= this.Ib) {
							Vb.disactivate();
							break;
						}
					}

					this.Ob = Tb;
				}
				Rb += Sb;
				Vb.Rb = Rb;

				if (Ab)
					ctx.T(Vb.Ab, Ab);

				if (Mc)
					ctx.T(Vb.Mc, Mc);

				return ic;
			}
		}

		// ac

		function ac() {
			this.Gb = 1;
			this.Kb = 0;
			this.Lb = 1;

			Vb.we.Mb(this); // IMPL

			this.Nb = function () {
				this.bc = this.Gb;
			}

			this.Nb();
		}

		ac.prototype = {
			Jd: function () {
				this.Nb();
			},

			Id: function (Qb, Ab, Mc) {
				Vb.we.Pb(Qb, Vb, this); // IMPL

				var cc = Vb.Rb;
				var dc = cc + Qb;
				var systemTimeBeforeFrame = Ld.Rb;
				var systemTimeAfterFrame = systemTimeBeforeFrame + Qb;
				var ec = Ab ? ctx.O(ctx.h(Ab, Vb.Bb)) : 0;
				var ic = 0;

				if (ec > 0.000001) {
					var fc = ec / this.rd;
					var Tb = this.bc + fc;

					var hc = fc < 0.001 ?
						1.0 - this.bc : (1.0 - this.bc) / fc;

					var jc = [];

					while (Tb > 1.0) {
						var kc = cc + hc * Qb;

						if (Ab)
							ctx.ab(jc, Vb.Bb, Ab, hc);

						if (Mc)
							ctx.slerpq(currentEmitterRot, Vb.prevRotation, Mc, hc);

						Vb.Rb = kc;
						ctx.T(Vb.Ab, jc);
						Ld.Rb = ctx.X(systemTimeBeforeFrame, systemTimeAfterFrame, hc);

						// for the future when Jb would be external
						this.Lb = this.Jb;

						for (var Wb = 0; Wb < this.Jb; ++Wb) {
							if (Vb.sc.length == 0)
								break;

							if (this.Jb == 1)
								this.Kb = 0;
							else
								this.Kb = Wb / (this.Jb - 1);

							var Xb = Vb.sc.pop();
							Vb.tc.unshift(Xb);

							if (Wb == 0)
								Xb.Yb();
							else
								Xb.Zb();

							Xb.Id(Qb * (1.0 - hc));
							++ic;
						}

						hc += 1.0 / fc;
						Tb -= 1.0;
					}

					this.bc = Tb;
				}

				Vb.Rb = dc;

				if (Ab)
					ctx.T(Vb.Ab, Ab);

				if (Mc)
					ctx.U(Vb.Mc, Mc);

				return ic;
			}
		}

		// mc

		function mc() {
			this.Ab = [];
			this.Pd = [];
			this.Nd = [];
			this.gf = [];
			this.Kc = [];
		}

		mc.prototype = {
			nc: function () {
				this.oc = false;

				for (var i = 0; i < this.Kc.length; ++i) {
					var pc = this.Kc[i];
					pc.Bd.Jd(this.Ab, null);

					if (pc.Ad.sd)
						pc.Bd.disactivate();
				}
			},

			Yb: function () {
				Vb.we.fd(Vb, this); // IMPL
				this.nc();
			},

			Zb: function () {
				Vb.we.gd(Vb, this); // IMPL
				this.nc();
			},

			Id: function (Qb) {
				Vb.we.qc(Qb, Vb, this); // IMPL

				this.rc(Qb);
			},

			pc: function (je) {
				return this.Kc[je].Bd;
			},

			rc: function (Qb) {
				for (var i = 0; i < this.Kc.length; i++) {
					this.Kc[i].Bd.Id(Qb, this.Ab, null);
				}
			},

			uc: function (md, nd) {
				this.Kc.push({
					Bd: new ld(Ld, md, ve),
					Ad: nd
				});
			},

			vc: function (fe, xc, ge) {
				for (var i = 0; i < this.Kc.length; ++i) {
					var pc = this.Kc[i];

					if (xc == pc.Ad.xc)
						pc.Bd.Hd(fe, ge);
				}
			},

			Ce: function (xc, se, re, te, renderBuffer) {
				for (var i = 0; i < this.Kc.length; ++i) {
					var pc = this.Kc[i];

					if (xc == pc.Ad.xc)
						pc.Bd.ue(se, re, te, renderBuffer);
				}
			},

			wc: function (fe) {
				this.oc = true;
				for (var i = 0; i < this.Kc.length; ++i) {
					var pc = this.Kc[i];

					if (pc.Ad.sd)
						pc.Bd.activate();
					else
						pc.Bd.disactivate();
				}
			},

			yc: function (Gd) {
				for (var i = 0; i < this.Kc.length; ++i) {
					this.Kc[i].Bd.Ed(Gd);
				}
			}
		}

		// zc

		function zc() {
		}

		zc.prototype.Ac = function (Xb) {
			return Vb.we.Cc(Vb, Xb, this); // IMPL
		}

		// ld Ad

		this.Ab = [];
		this.Bb = [];
		this.Mc = [];
		this.prevRotation = [];
		this.tc = [];
		this.sc = [];
		this.Wc = new zc();
		this.construct = new ve(this.Ld, this);
		this.Yc = [];
		this.ad = [];

		this.dd = function () {
			this.vd = new Eb();
		}

		this.ed = function () {
			this.vd = new ac();
		}

		this.we.ud(this); // IMPL

		for (var Wb = 0; Wb < this.jd; ++Wb) {
			var Xb = new mc();

			for (var id = 0; id < this.Yc.length; ++id) {
				var hd = this.Yc[id];
				Xb.uc(hd.Db, hd.Ad);
			}

			this.sc.push(Xb);
		}

		this.Nb = function (Ab, Mc) {

			ctx.T(this.Ab, Ab ? Ab : [0, 0, 0]);
			ctx.T(this.Bb, this.Ab);
			ctx.U(this.Mc, Mc ? Mc : [0, 0, 0, 1]);
			ctx.U(this.prevRotation, this.Mc);

			this.Rb = 0.0;
			this.wd = 0.0;
			this.Zc = true;
			this.paused_ = false;
			this.generatorsPaused_ = false;
			ctx.W(this.ad, 0, 0, 0);
		}
	}

	ld.prototype.Jd = function (Ab, Mc) {
		this.Nb(Ab, Mc);

		this.sc.push.apply(this.sc, this.tc);
		this.tc.length = 0;

		this.vd.Jd();
	}

	ld.prototype.Id = function (Qb, Ab, Mc) {

		if (this.paused_)
		{
			this.Td(Ab, Mc);
			return;
		}

		this.wd = this.Rb;

		if (Ab) {
			ctx.T(this.Bb, this.Ab);
			if (Qb > 0.0001) {
				var shift = [];
				ctx.g(shift, Ab, this.Bb);
				ctx.T(this.ad, shift);
				ctx.w(this.ad, this.ad, Qb);
			}
			else {
				ctx.W(this.ad, 0, 0, 0);
			}
		}
		else {
			ctx.W(this.ad, 0, 0, 0);
		}

		if (Mc)
		{
			ctx.U(this.prevRotation, this.Mc);
		}

		var ic;

		if (this.Zc && !this.generatorsPaused_) {
			ic = this.vd.Id(Qb, Ab, Mc);
		}
		else {
			if (Ab)
				ctx.T(this.Ab, Ab);

			if (Mc)
				ctx.U(this.Mc, Mc);

			ic = 0;
			this.Rb += Qb;
		}

		for (var Wb = ic; Wb < this.tc.length;) {
			var Xb = this.tc[Wb];

			if (!Xb.oc) {
				Xb.Id(Qb);

				if (this.Wc.Ac(this.tc[Wb])) {
					Xb.wc();

					if (this.xd(Wb))
						continue;
				}
			}
			else {
				Xb.rc(Qb);

				if (this.xd(Wb))
					continue;
			}

			++Wb;
		}
	};

	ld.prototype.xd = function (je) {
		var Xb = this.tc[je];

		var ready = true;

		for (var id = 0; id < Xb.Kc.length; ++id) {
			var Bd = Xb.Kc[id].Bd;

			if (Bd.activated() || Bd.tc.length > 0) {
				ready = false;
				break;
			}
		}

		if (ready) {
			this.sc.push(this.tc[je]);
			this.tc.splice(je, 1);
			return true;
		}

		return false;
	}

	ld.prototype.Hd = function (fe, ge) {
		this.construct.Hd(fe, ge);
	}

	ld.prototype.ue = function (se, re, te, renderBuffer) {
		this.construct.ue(se, re, te, renderBuffer);
	}

	ld.prototype.Td = function (Ab, Mc) {
		this.wd = this.Rb;

		if (Ab) {
			ctx.T(this.Bb, this.Ab);
			ctx.T(this.Ab, Ab);
		}

		if (Mc) {
			ctx.U(this.prevRotation, this.Mc);
			ctx.U(this.Mc, Mc);
		}
	}

	ld.prototype.uc = function (md, nd) {
		this.Yc.push({ Db: md, Ad: nd });
	}

	ld.prototype./**/pause = function () {
		this.paused_ = true;
	}

	ld.prototype./**/unpause = function () {
		this.paused_ = false;
	}

	ld.prototype./**/paused = function () {
		return this.paused_;
	}

	ld.prototype./**/pauseGenerators = function () {
		this.generatorsPaused_ = true;
	}

	ld.prototype./**/unpauseGenerators = function () {
		this.generatorsPaused_ = false;
	}

	ld.prototype./**/generatorsPaused = function () {
		return this.generatorsPaused_;
	}

	ld.prototype.activate = function () {
		this.Zc = true;
	}

	ld.prototype.disactivate = function () {
		this.Zc = false;
	}

	ld.prototype.activated = function () {
		return this.Zc;
	}

	ld.prototype./**/getNumParticles = function () {
		return this.tc.length;
	}

	var ke = function () {
		var Cb = this;

		this._init = function (we, Ab, Mc, ve) {
			this./**/model = we;

			this.Ab = [];
			this.Mc = [];

			// ke Ad

			this.od = [];

			this.pd = function (md) {
				var Bd = new ld(this, md, ve);
				Bd.Nb(this.Ab, this.Mc);
				this["_".concat(md.name)] = Bd;
				this.od.push(Bd);
			}

			this.Nb = function (Ab, Mc) {
				this.Cd = 0.0;
				this.Rb = 0.0;
				ctx.T(this.Ab, Ab ? Ab : [0, 0, 0]);
				ctx.U(this.Mc, Mc ? Mc : [0, 0, 0, 1]);
			}

			this.Nb(Ab, Mc);
			this./**/model.qd(this); // IMPL
			this.zeroUpdate();
			this./**/update(this.Ud, Ab, Mc);
		}
	}

	ke.prototype./**/restart = function (/**/position, /**/rotation) {

		this.Nb(/**/position ? /**/position : this.Ab, /**/rotation ? /**/rotation : this.Mc);

		for (var i = 0; i < this.od.length; ++i) {
			this.od[i].Jd(this.Ab, this.Mc);
		}

		this.zeroUpdate();

		this./**/update(this.Ud, this.Ab, this.Mc);
	}

	ke.prototype.zeroUpdate = function () {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i].Id(0, this.Ab, this.Mc);
		}
	}

	ke.prototype./**/update = function (/**/dt, /**/position, /**/rotation) {
		var updatedTime = 0.0;
		var hc = [];
		ctx.T(hc, this.Ab);
		var frameRotation = [];
		ctx.U(frameRotation, this.Mc);

		if (/**/position && ctx.equalv3_(/**/position, this.Ab))
			/**/position = null;

		if (/**/rotation && ctx.equalq_(/**/rotation, this.Mc))
			/**/rotation = null;

		while ((/**/dt - updatedTime) + this.Cd >= this.Dd) {
			var cc = this.Rb;

			if (/**/position)
				ctx.ab(hc, this.Ab, /**/position, updatedTime / /**/dt);

			if (/**/rotation)
				ctx.slerpq(frameRotation, this.Mc, /**/rotation, updatedTime / /**/dt);

			for (var i = 0; i < this.od.length; ++i) {
				this.od[i].Id(this.Dd, hc, frameRotation);

				this.Rb = cc;
			}

			updatedTime += this.Dd - this.Cd;
			this.Cd = 0.0;
			this.Rb = cc + this.Dd;
		}

		if (/**/position)
			ctx.T(this.Ab, /**/position);

		if (/**/rotation)
			ctx.U(this.Mc, /**/rotation);

		this.Cd += /**/dt - updatedTime;
	}

	ke.prototype./**/resetPosition = function (/**/position, /**/rotation) {

		if (/**/position)
			ctx.T(this.Ab, /**/position);

		if (/**/rotation)
			ctx.U(this.Mc, /**/rotation);

		for (var i = 0; i < this.od.length; ++i) {
			this.od[i].Td(this.Ab, this.Mc);
		}
	}

	ke.prototype./**/setPropertyInAllEmitters = function (/**/name, /**/value) {
		var propName = "_".concat(/**/name);

		if (/**/value instanceof Array) {
			if (/**/value.length == 2) {
				for (var i = 0; i < this.od.length; ++i) {
					ctx.S(this.od[i][propName], /**/value);
				}
			}
			else {
				for (var i = 0; i < this.od.length; ++i) {
					ctx.T(this.od[i][propName], /**/value);
				}
			}
		}
		else {
			for (var i = 0; i < this.od.length; ++i) {
				this.od[i][propName] = /**/value;
			}
		}
	}

	ke.prototype./**/pauseAllEmitters = function() {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i]./**/pause();
		}
	}

	ke.prototype./**/unpauseAllEmitters = function () {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i]./**/unpause();
		}
	}

	ke.prototype./**/areAllEmittersPaused = function () {
		for (var i = 0; i < this.od.length; ++i) {
			if (!this.od[i].paused())
				return false;
		}
		return true;
	}

	ke.prototype./**/pauseGeneratorsInAllEmitters = function () {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i]./**/pauseGenerators();
		}
	}

	ke.prototype./**/unpauseGeneratorsInAllEmitters = function () {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i]./**/unpauseGenerators();
		}
	}

	ke.prototype./**/areGeneratorsInAllEmittersPaused = function () {
		for (var i = 0; i < this.od.length; ++i) {
			if (!this.od[i].generatorsPaused())
				return false;
		}
		return true;
	}

	ke.prototype./**/getNumParticles = function() {
		var numParticles = 0;

		for (var i = 0; i < this.od.length; ++i) {
			numParticles += this.od[i].getNumParticles();
		}

		return numParticles;
	}


	var le = function () {
		this._init = function (we, Ab, Mc, renderBuffer) {
			le.prototype._init.call(this, we, Ab, Mc, oe);

			this.texturesRemap = [];

			var indices = [];

			{
				var verDisp;
				for (var Wb = 0; Wb < this./**/model.Xe; ++Wb) {
					verDisp = Wb * 4;
					indices.push(verDisp + 0, verDisp + 3, verDisp + 1, verDisp + 1, verDisp + 3, verDisp + 2);
				}
			}

			this.renderBuffer = renderBuffer;
			this.renderBuffer.initialize(this./**/model.Xe * 4, [2], indices, this./**/model.Xe);
			this.renderBuffer.__numIndices = 0;
		}
	}

	le.prototype = new ke();

	le.prototype./**/fillGeometryBuffers = function (/**/cameraRight, /**/cameraUp, /**/cameraDir) {
		this.renderBuffer.cleanup();
		this.renderBuffer.__lastRenderCall = null;

		this.od.forEach(function (Bd) {
			Bd.ue(/**/cameraRight, /**/cameraUp, /**/cameraDir, this.renderBuffer);
		}, this);

		if (this.renderBuffer.__lastRenderCall)
			this.renderBuffer.pushRenderCall(this.renderBuffer.__lastRenderCall);
	}

	var me = function () {
		this._init = function (we, Ab, Mc) {
			me.prototype._init.call(this, we, Ab, Mc, ne);

			this.materials = [];
			this./**/model.materials.forEach(function (value) {
				this.materials.push(['source-over', 'lighter', 'multiply'][value]);
			}, this);

			this./**/textureDescs = [];
		}
	}

	me.prototype = new ke();

	me.prototype./**/draw = function (/**/context, /**/camera) {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i].Hd(/**/context, /**/camera);
		}
	}

	this.createWGLInstance = function (/**/position, /**/rotation, /**/renderBuffer) {
		var Ld = new le();
		Ld._init(this, /**/position, /**/rotation, /**/renderBuffer);
		return Ld;
	}

	this.createCanvas2DInstance = function (/**/position, /**/rotation) {
		var Ld = new me();
		Ld._init(this, /**/position, /**/rotation);
		return Ld;
	}
	this.textures = ['leaves_green_2x2.png','sparks_core.png','flare.png'];
	this.materials = [0,1];
	this.renderStyles = [{materialIndex:0,textureIndices:[0]},{materialIndex:1,textureIndices:[1]},{materialIndex:1,textureIndices:[2]}];
	this.Xe = 700;

	function Emitter_Leaves_Middle() {

		var _2s = [[9.64, 9.8], [19.28, 9.8], [19.28, 19.6], [28.92, 19.6], [9.64, 19.6]], _1, _2Srch, _2 = [], _3 = [], _5 = [], _7, _9, _11, _13, _15, _17, _19 = [], _20=[], _20a=[], _20i=[], _21=[], _21fs=[], _21vs=[], _21rw=[], _21rwn=[], _21rwl, _21v=[], _21p=[], _21dtl, _21dtp, _21df, _21fsd=[], _22, _23, _24, _25 = [], _25i0, _25s0 = [], _25i1, _25s1 = [], _25i2, _25s2 = [], _26, _26i0, _26s0 = [];
		this.pe = [{xe:0,Rc:2,Sc:2,renderStyleIndex:0}];
		this.name = "Leaves_Middle";

		this.ud = function(Bd) {
			Bd.dd();
			Bd._25 = [
				[
					[1,0.7,0.7],
					[0.7,0.9,0.9],
					[0.9,0.4,0.4]
				],
				[
					[1,0.7,0.7],
					[0.7,0.9,0.9],
					[0.9,0.4,0.4]
				],
				[
					[1,0.7,0.7],
					[0.7,0.9,0.9],
					[0.9,0.4,0.4]
				]
			];
			Bd._26 = [
				[
					[0,1,1],
					[1,1,1],
					[1,0,0]
				]
			];
			Bd.jd = 250;
			Bd.Vc = 0;
		}

		this.Mb = function(vd) {
			vd.zb = 2;
			vd.Gb = 1;
			vd.Jb = 1;
		}

		this.Pb = function(Qb, Bd, vd) {
			vd.zb = 2;
		}

		this.fd = function(Bd, Xb) {
			Xb._ = 0.0;
			_1 = 0 + Bd.Ld.rand() * (1 - 0);
			_2Srch = this._2f(_1 * 43265);
			ctx.yb(_2, -57 + (_2Srch[0] % 25) * 9.64, -114 + Math.floor(_2Srch[0] / 25) * 9.8, _2s[_2Srch[1]], Bd.Ld.rand);
			ctx.W(_3, _2[0], _2[1], 0);
			Xb._4 = [];
			ctx.c(Xb._4, Bd.Ab, _3);
			ctx.W(_5, 0, 0, 0);
			Xb._6 = [];
			ctx.T(Xb._6, _5);
			_7 = 0 + Bd.Ld.rand() * (360 - 0);
			Xb._8 = _7;
			_9 = 10 + Bd.Ld.rand() * (20 - 10);
			Xb._10 = _9;
			_11 = 0.5 + Bd.Ld.rand() * (0.9 - 0.5);
			Xb._12 = _11;
			_13 = 100 + Bd.Ld.rand() * (300 - 100);
			Xb._14 = _13;
			_15 = 0 + Bd.Ld.rand() * (4 - 0);
			Xb._16 = _15;
			_17 = -160 + Bd.Ld.rand() * (160 - -160);
			Xb._18 = _17;
			ctx.T(Xb.Ab, Xb._4);
		}

		this.gd = function(Bd, Xb) {
			Xb._ = 0.0;
			_1 = 0 + Bd.Ld.rand() * (1 - 0);
			_2Srch = this._2f(_1 * 43265);
			ctx.yb(_2, -57 + (_2Srch[0] % 25) * 9.64, -114 + Math.floor(_2Srch[0] / 25) * 9.8, _2s[_2Srch[1]], Bd.Ld.rand);
			ctx.W(_3, _2[0], _2[1], 0);
			Xb._4 = [];
			ctx.c(Xb._4, Bd.Ab, _3);
			ctx.W(_5, 0, 0, 0);
			Xb._6 = [];
			ctx.T(Xb._6, _5);
			_7 = 0 + Bd.Ld.rand() * (360 - 0);
			Xb._8 = _7;
			_9 = 10 + Bd.Ld.rand() * (20 - 10);
			Xb._10 = _9;
			_11 = 0.5 + Bd.Ld.rand() * (0.9 - 0.5);
			Xb._12 = _11;
			_13 = 100 + Bd.Ld.rand() * (300 - 100);
			Xb._14 = _13;
			_15 = 0 + Bd.Ld.rand() * (4 - 0);
			Xb._16 = _15;
			_17 = -160 + Bd.Ld.rand() * (160 - -160);
			Xb._18 = _17;
			ctx.T(Xb.Ab, Xb._4);
		}

		this.qc = function(Qb, Bd, Xb) {
			Xb._ += Qb;
			ctx.W(_19, 0, 200, 0);
			ctx.u(_20a, [100,50,30], Bd.Ld.Rb);
			ctx.c(_20a, _20a, Xb._4);
			ctx.u(_20i, _20a, 1.0 / 1000);
			ctx.xb(_20, _20i);
			ctx.k(_20, _20, [0.0078125,0.0078125,0.0078125]);
			ctx.c(_20, _20, [-1,-1,-1]);
			ctx.u(_20, _20, Xb._14);
			ctx.T(_21fs, _19);
			ctx.c(_21fs, _21fs, _20);
			ctx.T(_21vs, [0,0,0]);
			ctx.u(_21v, _21fs, Qb);
			ctx.c(_21v, _21v, Xb._6);
			ctx.u(_21p, _21v, Qb);
			ctx.c(_21p, _21p, Xb._4);
			ctx.T(Xb._4, _21p);
			ctx.T(Xb._6, _21v);
			_22 = Xb._8 + Qb * Xb._18;
			Xb._8 = _22;
			ctx.T(Xb.Ab, Xb._4);
			_23 = 4;
			_24 = (Xb._ / _23);
			_25i0=(_24<0?0:(_24>1?1:_24));
			_25i0<0.4?_25i0<0.2?ctx.V(_25s0,0,(_25i0-0)*5):ctx.V(_25s0,1,(_25i0-0.2)*5):ctx.V(_25s0,2,(_25i0-0.4)*1.66667);
			_25i1=(_24<0?0:(_24>1?1:_24));
			_25i1<0.4?_25i1<0.2?ctx.V(_25s1,0,(_25i1-0)*5):ctx.V(_25s1,1,(_25i1-0.2)*5):ctx.V(_25s1,2,(_25i1-0.4)*1.66667);
			_25i2=(_24<0?0:(_24>1?1:_24));
			_25i2<0.4?_25i2<0.2?ctx.V(_25s2,0,(_25i2-0)*5):ctx.V(_25s2,1,(_25i2-0.2)*5):ctx.V(_25s2,2,(_25i2-0.4)*1.66667);
			ctx.W(_25, Db.nb(Bd._25[0][_25s0[0]],_25s0[1]),Db.nb(Bd._25[1][_25s1[0]],_25s1[1]),Db.nb(Bd._25[2][_25s2[0]],_25s2[1]));
			_26i0=(_24<0?0:(_24>1?1:_24));
			_26i0<0.8?_26i0<0.2?ctx.V(_26s0,0,(_26i0-0)*5):ctx.V(_26s0,1,(_26i0-0.2)*1.66667):ctx.V(_26s0,2,(_26i0-0.8)*5);
			_26 = Db.nb(Bd._26[0][_26s0[0]],_26s0[1]);
			ctx.S(Xb.Pd,[0.5,0.5]);
			Xb.Md = Xb._8;
			ctx.V(Xb.Nd,Xb._10,Xb._10);
			ctx.T(Xb.gf,_25);
			Xb.Od = _26;
			Xb.Qc = Xb._16;
		}

		this.Cc = function(Bd, Xb, Wc) {
			_23 = 4;
			return Xb._ > _23;
		}

			this._2f = function(i) {
				return i<19503?i<9983?i<4106?i<1922?i<298?i<23?[126,0]:i<152?[127,0]:[128,0]:i<902?i<526?i<311?[150,0]:[151,0]:i<647?[175,0]:[176,0]:[152,2]:i<2578?i<2229?i<1925?[105,0]:i<2026?[129,0]:[130,0]:i<2324?[106,0]:[131,0]:i<3597?i<3088?[154,1]:i<3342?[179,0]:[180,0]:i<3852?[156,0]:[181,0]:i<4431?i<4334?i<4198?i<4114?[82,0]:[83,0]:[84,0]:i<4427?[85,0]:[86,0]:i<7451?i<5922?i<5414?i<4905?i<4651?[107,0]:[108,0]:i<5160?[132,0]:[133,0]:[109,4]:i<6942?[157,2]:i<7197?[159,0]:[184,0]:i<8454?i<8368?i<7859?i<7705?[110,0]:[111,0]:i<8114?[135,0]:[136,0]:[137,0]:i<9474?[160,2]:i<9729?[162,0]:[187,0]:i<15615?i<13413?i<11945?i<10925?i<10442?i<10187?[200,0]:[201,0]:i<10670?[225,0]:[226,0]:[202,2]:i<12488?i<12350?i<12095?[250,0]:[251,0]:i<12359?[275,0]:[276,0]:i<12998?[252,1]:i<13199?[277,0]:[278,0]:i<14940?i<14433?[204,2]:i<14688?[206,0]:[231,0]:i<15562?i<15403?i<15194?[254,0]:[255,0]:i<15548?[279,0]:[280,0]:[256,0]:i<17213?i<17015?i<16505?i<16125?[207,1]:i<16283?[232,0]:[233,0]:[209,4]:i<17048?[258,0]:[259,0]:i<18743?[210,3]:i<19260?i<19237?i<18983?[260,0]:[261,0]:i<19244?[285,0]:[286,0]:i<19497?[262,0]:[287,0]:i<30461?i<27120?i<23407?i<20432?i<19841?i<19528?[39,0]:i<19599?[15,0]:[40,0]:i<19936?i<19911?[64,0]:[89,0]:i<20190?[65,0]:[90,0]:i<21882?i<21388?i<20879?i<20639?[16,0]:[17,0]:i<21133?[41,0]:[42,0]:i<21628?[18,0]:[43,0]:i<22899?i<22391?i<22136?[66,0]:[67,0]:[91,1]:[68,4]:i<25254?i<23725?i<23570?i<23486?[138,0]:[139,0]:i<23641?[115,0]:[140,0]:i<24745?[163,2]:i<25000?[165,0]:[190,0]:i<26009?i<25769?i<25701?i<25461?[116,0]:[117,0]:i<25764?[141,0]:[142,0]:[118,0]:i<26970?i<26460?i<26263?[166,0]:[167,0]:[191,1]:i<26981?[168,0]:[193,0]:i<29845?i<29811?i<28322?i<28058?i<27550?i<27358?[19,0]:[20,0]:[44,1]:i<28103?[21,0]:[46,0]:i<29338?[69,2]:i<29592?[71,0]:[96,0]:i<29815?[47,0]:i<29841?[72,0]:[97,0]:i<30320?i<30275?i<30083?[119,0]:[120,0]:[121,0]:i<30448?i<30391?[194,0]:[195,0]:[196,0]:i<36437?i<36006?i<32948?i<31990?i<31481?[213,2]:i<31736?[215,0]:[240,0]:i<32458?i<32389?i<32158?[263,0]:[264,0]:[289,0]:i<32712?[265,0]:[290,0]:i<34478?[216,3]:i<35497?i<34987?i<34732?[266,0]:[267,0]:[291,1]:i<35751?[268,0]:[293,0]:i<36024?[315,0]:i<36286?i<36135?[316,0]:[317,0]:[318,0]:i<41662?i<39484?i<37957?i<37457?[219,2]:i<37702?[221,0]:[246,0]:i<38975?i<38465?[269,1]:[294,1]:i<39229?[271,0]:[296,0]:i<40225?i<40161?i<39667?i<39640?[222,0]:[223,0]:i<39922?[247,0]:[248,0]:[249,0]:i<41243?i<40733?[272,1]:[297,1]:i<41445?[274,0]:[299,0]:i<42395?i<42040?i<42032?i<41812?[319,0]:[320,0]:[345,0]:i<42295?[321,0]:[346,0]:i<43139?i<42904?i<42650?[322,0]:[323,0]:i<43051?[347,0]:[348,0]:i<43263?[324,0]:[349,0];
			}

	}

	function Emitter_Leaves_LeftAndRight() {

		var _2s = [[9.9881, 9.73913], [29.9643, 29.2174], [19.9762, 9.73913], [49.9405, 29.2174], [29.9643, 9.73913], [19.9762, 19.4783], [19.9762, 29.2174], [9.9881, 19.4783], [29.9643, 19.4783]], _1, _2Srch, _2 = [], _3 = [], _5 = [], _7, _9, _11, _13, _15, _17, _19 = [], _20=[], _20a=[], _20i=[], _21=[], _21fs=[], _21vs=[], _21rw=[], _21rwn=[], _21rwl, _21v=[], _21p=[], _21dtl, _21dtp, _21df, _21fsd=[], _22, _23, _24, _25 = [], _25i0, _25s0 = [], _25i1, _25s1 = [], _25i2, _25s2 = [], _26, _26i0, _26s0 = [];
		this.pe = [{xe:0,Rc:2,Sc:2,renderStyleIndex:0}];
		this.name = "Leaves_LeftAndRight";

		this.ud = function(Bd) {
			Bd.dd();
			Bd._25 = [
				[
					[1,0.8,0.8],
					[0.8,1,1]
				],
				[
					[1,0.8,0.8],
					[0.8,1,1]
				],
				[
					[1,0.8,0.8],
					[0.8,1,1]
				]
			];
			Bd._26 = [
				[
					[0,1,1],
					[1,1,1],
					[1,0,0]
				]
			];
			Bd.jd = 250;
			Bd.Vc = 0;
		}

		this.Mb = function(vd) {
			vd.zb = 7;
			vd.Gb = 1;
			vd.Jb = 1;
		}

		this.Pb = function(Qb, Bd, vd) {
			vd.zb = 7;
		}

		this.fd = function(Bd, Xb) {
			Xb._ = 0.0;
			_1 = 0 + Bd.Ld.rand() * (1 - 0);
			_2Srch = this._2f(_1 * 166051);
			ctx.yb(_2, -466 + (_2Srch[0] % 84) * 9.9881, -384 + Math.floor(_2Srch[0] / 84) * 9.73913, _2s[_2Srch[1]], Bd.Ld.rand);
			ctx.W(_3, _2[0], _2[1], 0);
			Xb._4 = [];
			ctx.c(Xb._4, Bd.Ab, _3);
			ctx.W(_5, 0, 0, 0);
			Xb._6 = [];
			ctx.T(Xb._6, _5);
			_7 = 0 + Bd.Ld.rand() * (360 - 0);
			Xb._8 = _7;
			_9 = 6 + Bd.Ld.rand() * (12 - 6);
			Xb._10 = _9;
			_11 = 0.5 + Bd.Ld.rand() * (0.9 - 0.5);
			Xb._12 = _11;
			_13 = 50 + Bd.Ld.rand() * (150 - 50);
			Xb._14 = _13;
			_15 = 0 + Bd.Ld.rand() * (4 - 0);
			Xb._16 = _15;
			_17 = -160 + Bd.Ld.rand() * (160 - -160);
			Xb._18 = _17;
			ctx.T(Xb.Ab, Xb._4);
		}

		this.gd = function(Bd, Xb) {
			Xb._ = 0.0;
			_1 = 0 + Bd.Ld.rand() * (1 - 0);
			_2Srch = this._2f(_1 * 166051);
			ctx.yb(_2, -466 + (_2Srch[0] % 84) * 9.9881, -384 + Math.floor(_2Srch[0] / 84) * 9.73913, _2s[_2Srch[1]], Bd.Ld.rand);
			ctx.W(_3, _2[0], _2[1], 0);
			Xb._4 = [];
			ctx.c(Xb._4, Bd.Ab, _3);
			ctx.W(_5, 0, 0, 0);
			Xb._6 = [];
			ctx.T(Xb._6, _5);
			_7 = 0 + Bd.Ld.rand() * (360 - 0);
			Xb._8 = _7;
			_9 = 6 + Bd.Ld.rand() * (12 - 6);
			Xb._10 = _9;
			_11 = 0.5 + Bd.Ld.rand() * (0.9 - 0.5);
			Xb._12 = _11;
			_13 = 50 + Bd.Ld.rand() * (150 - 50);
			Xb._14 = _13;
			_15 = 0 + Bd.Ld.rand() * (4 - 0);
			Xb._16 = _15;
			_17 = -160 + Bd.Ld.rand() * (160 - -160);
			Xb._18 = _17;
			ctx.T(Xb.Ab, Xb._4);
		}

		this.qc = function(Qb, Bd, Xb) {
			Xb._ += Qb;
			ctx.W(_19, 0, 100, 0);
			ctx.u(_20a, [100,50,30], Bd.Ld.Rb);
			ctx.c(_20a, _20a, Xb._4);
			ctx.u(_20i, _20a, 1.0 / 1000);
			ctx.xb(_20, _20i);
			ctx.k(_20, _20, [0.0078125,0.0078125,0.0078125]);
			ctx.c(_20, _20, [-1,-1,-1]);
			ctx.u(_20, _20, Xb._14);
			ctx.T(_21fs, _19);
			ctx.c(_21fs, _21fs, _20);
			ctx.T(_21vs, [0,0,0]);
			ctx.u(_21v, _21fs, Qb);
			ctx.c(_21v, _21v, Xb._6);
			ctx.u(_21p, _21v, Qb);
			ctx.c(_21p, _21p, Xb._4);
			ctx.T(Xb._4, _21p);
			ctx.T(Xb._6, _21v);
			_22 = Xb._8 + Qb * Xb._18;
			Xb._8 = _22;
			ctx.T(Xb.Ab, Xb._4);
			_23 = 4;
			_24 = (Xb._ / _23);
			_25i0=(_24<0?0:(_24>1?1:_24));
			_25i0<0.2?ctx.V(_25s0,0,(_25i0-0)*5):ctx.V(_25s0,1,(_25i0-0.2)*1.25);
			_25i1=(_24<0?0:(_24>1?1:_24));
			_25i1<0.2?ctx.V(_25s1,0,(_25i1-0)*5):ctx.V(_25s1,1,(_25i1-0.2)*1.25);
			_25i2=(_24<0?0:(_24>1?1:_24));
			_25i2<0.2?ctx.V(_25s2,0,(_25i2-0)*5):ctx.V(_25s2,1,(_25i2-0.2)*1.25);
			ctx.W(_25, Db.nb(Bd._25[0][_25s0[0]],_25s0[1]),Db.nb(Bd._25[1][_25s1[0]],_25s1[1]),Db.nb(Bd._25[2][_25s2[0]],_25s2[1]));
			_26i0=(_24<0?0:(_24>1?1:_24));
			_26i0<0.8?_26i0<0.2?ctx.V(_26s0,0,(_26i0-0)*5):ctx.V(_26s0,1,(_26i0-0.2)*1.66667):ctx.V(_26s0,2,(_26i0-0.8)*5);
			_26 = Db.nb(Bd._26[0][_26s0[0]],_26s0[1]);
			ctx.S(Xb.Pd,[0.5,0.5]);
			Xb.Md = Xb._8;
			ctx.V(Xb.Nd,Xb._10,Xb._10);
			ctx.T(Xb.gf,_25);
			Xb.Od = _26;
			Xb.Qc = Xb._16;
		}

		this.Cc = function(Bd, Xb, Wc) {
			_23 = 4;
			return Xb._ > _23;
		}

			this._2f = function(i) {
				return i<73895?i<63043?i<35662?i<17555?i<3023?i<1318?i<104?[422,0]:i<556?i<354?i<188?[339,0]:[340,0]:[341,0]:[423,4]:i<2120?i<1484?i<1483?i<1468?[342,0]:[343,0]:[344,0]:i<1923?i<1738?[426,0]:[427,0]:[428,0]:i<2515?i<2158?[262,0]:i<2269?[345,0]:[346,0]:[429,2]:i<9910?i<6248?i<3958?i<3552?i<3082?[589,0]:i<3298?[506,0]:[590,0]:i<3704?[673,0]:[674,0]:i<5486?i<4976?i<4467?i<4213?[507,0]:[508,0]:i<4722?[591,0]:[592,0]:[509,7]:[675,4]:i<7622?i<7198?i<6689?i<6464?[757,0]:[841,0]:i<6944?[758,0]:[842,0]:i<7367?[925,0]:[926,0]:i<9147?i<8639?i<8131?i<7877?[759,0]:[760,0]:[843,2]:[761,7]:i<9656?i<9402?[927,0]:[928,0]:[929,0]:i<13734?i<12204?i<11440?[510,8]:i<11950?[678,2]:[680,0]:[513,6]:i<16027?i<15262?i<14753?i<14244?[762,2]:i<14498?[846,0]:[847,0]:i<15008?[764,0]:[848,0]:[930,4]:i<17045?i<16537?[765,2]:[849,2]:[933,2]:i<23007?i<22202?i<18433?i<18013?i<17585?[97,0]:i<17761?i<17595?[179,0]:[180,0]:[181,0]:i<18040?[98,0]:i<18291?[182,0]:[183,0]:i<20674?i<19912?i<19402?i<18892?i<18637?[263,0]:[264,0]:[347,2]:[265,7]:[431,4]:i<21693?i<21183?i<20929?[266,0]:[267,0]:[350,2]:i<21947?[434,0]:[435,0]:i<23005?i<22362?i<22255?[268,0]:i<22347?[352,0]:[353,0]:i<22861?i<22613?[436,0]:[437,0]:[438,0]:[439,0]:i<30652?i<26831?i<25301?i<24537?[515,8]:i<25046?i<24792?[683,0]:[684,0]:[685,0]:[518,6]:i<29123?i<28358?i<27849?i<27341?[767,2]:[851,2]:i<28104?[769,0]:[853,0]:[935,4]:i<30142?i<29633?[770,2]:i<29887?[854,0]:[855,0]:[938,2]:i<33237?i<32945?i<32181?i<31672?[520,5]:i<31926?[522,0]:[606,0]:i<32690?i<32435?[688,0]:[689,0]:[690,0]:i<33133?i<33016?[523,0]:[607,0]:[691,0]:i<35127?i<34636?i<34255?i<33747?[772,2]:[856,2]:i<34499?[774,0]:[858,0]:i<35107?i<34891?[940,0]:[941,0]:[942,0]:i<35250?i<35154?[775,0]:[860,0]:i<35409?[943,0]:[944,0]:i<43288?i<42979?i<36966?i<36948?i<35974?i<35710?[1009,0]:i<35948?[1010,0]:[1094,0]:i<36874?i<36625?i<36482?[1011,2]:i<36570?[1095,0]:[1096,0]:i<36830?[1013,0]:[1097,0]:[1181,0]:[1265,0]:i<40764?i<39236?i<38471?i<37962?i<37454?i<37199?[1014,0]:[1015,0]:i<37707?[1098,0]:[1099,0]:i<38216?[1016,0]:[1100,0]:[1182,4]:i<40254?i<39744?[1017,2]:[1101,2]:[1185,2]:i<41928?i<41474?i<41254?i<40999?[1266,0]:[1267,0]:i<41303?[1350,0]:[1351,0]:i<41729?[1268,0]:[1352,0]:i<42785?i<42438?[1269,2]:i<42604?[1353,0]:[1354,0]:[1438,0]:i<43287?i<43177?[1522,0]:[1606,0]:[1690,0]:i<58219?i<50933?i<47108?i<45580?i<44815?i<44306?i<43796?[1019,2]:[1103,2]:i<44560?[1021,0]:[1105,0]:[1187,4]:i<46598?i<46088?[1022,2]:[1106,2]:[1190,2]:[1271,3]:i<54403?i<52875?i<52110?i<51699?i<51246?i<51187?[1024,0]:[1025,0]:i<51485?[1108,0]:[1109,0]:i<51856?[1026,0]:[1110,0]:[1192,4]:i<53893?i<53383?[1027,2]:[1111,2]:[1195,2]:i<56697?i<55933?[1276,8]:i<56443?[1444,2]:[1446,0]:i<57717?[1279,5]:i<57964?[1447,0]:[1448,0]:i<61764?i<61707?i<60362?i<59748?i<59238?i<58729?[1523,2]:i<58983?[1607,0]:[1608,0]:[1525,7]:i<60108?i<59865?[1691,0]:[1692,0]:[1693,0]:i<61382?[1526,5]:i<61604?[1694,0]:[1695,0]:i<61761?i<61724?[1776,0]:[1777,0]:[1778,0]:i<62552?i<62548?i<62469?i<62240?i<62019?[1528,0]:[1529,0]:i<62440?[1612,0]:[1613,0]:[1530,0]:[1696,0]:i<62926?i<62672?[1531,0]:[1532,0]:i<62929?[1615,0]:[1616,0]:i<65918?i<63272?i<63267?i<63123?[694,0]:[695,0]:[696,0]:i<65410?i<64645?i<64138?i<63633?i<63380?[777,0]:[778,0]:i<63884?[861,0]:[862,0]:i<64391?[779,0]:[863,0]:[945,4]:i<65625?i<65453?[780,0]:[864,0]:i<65878?[948,0]:[949,0]:i<73102?i<69492?i<68210?i<67445?i<66936?i<66426?[1029,2]:[1113,2]:i<67190?[1031,0]:[1115,0]:[1197,4]:i<69008?i<68582?i<68464?[1032,0]:[1033,0]:i<68837?[1116,0]:[1117,0]:i<69491?i<69263?[1200,0]:[1201,0]:[1202,0]:i<71787?[1281,1]:i<72842?i<72805?i<72296?i<72042?[1284,0]:[1285,0]:i<72551?[1368,0]:[1369,0]:i<72822?[1286,0]:[1370,0]:i<73042?[1452,0]:[1453,0]:i<73892?i<73792?i<73590?i<73357?[1533,0]:[1534,0]:i<73762?[1617,0]:[1618,0]:[1535,0]:[1536,0]:i<100959?i<98287?i<74672?i<74010?i<73916?[388,0]:[472,0]:i<74593?i<74394?i<74181?[556,0]:[640,0]:[724,0]:[808,0]:i<84390?i<79576?i<75871?i<75301?i<74802?i<74694?[138,0]:[139,0]:i<75047?i<74824?[221,0]:[222,0]:[223,0]:i<75411?i<75400?[140,0]:[141,0]:i<75665?[224,0]:[225,0]:i<78047?i<77285?i<76775?i<76274?i<76019?[305,0]:[306,0]:i<76520?[389,0]:[390,0]:[307,7]:[473,4]:i<79067?[308,5]:i<79321?[476,0]:[477,0]:i<80757?i<80544?i<79805?i<79706?i<79598?[142,0]:[143,0]:[144,0]:i<80290?i<80035?[226,0]:[227,0]:[228,0]:i<80555?[145,0]:i<80752?[229,0]:[230,0]:i<83049?i<82287?[310,8]:[478,4]:i<83882?i<83381?i<83303?[313,0]:[314,0]:i<83636?[397,0]:[398,0]:[481,2]:i<90642?i<88214?i<86685?[557,1]:i<87705?[560,5]:i<87959?[728,0]:[729,0]:i<89248?i<89247?i<88858?i<88717?i<88462?[809,0]:[810,0]:i<88758?[893,0]:[894,0]:i<89113?[811,0]:[895,0]:[979,0]:i<90267?i<89758?[812,2]:i<90012?[896,0]:[897,0]:i<90399?[980,0]:[981,0]:i<94466?i<92936?i<92172?[562,8]:i<92681?i<92426?[730,0]:[731,0]:[732,0]:[565,6]:i<96759?i<95994?i<95484?i<94976?[814,2]:[898,2]:[816,7]:[982,4]:i<97777?i<97269?[817,2]:[901,2]:[985,2]:i<98295?[1065,0]:i<99531?i<99305?i<98796?i<98590?i<98339?[1066,0]:[1067,0]:i<98591?[1150,0]:[1151,0]:i<99050?[1068,0]:[1152,0]:i<99343?[1235,0]:[1236,0]:i<100549?i<100039?[1069,2]:[1153,2]:i<100775?[1237,0]:[1238,0]:i<128264?i<124218?i<109007?i<106643?i<102134?i<101262?i<100966?[149,0]:i<101045?i<100967?[231,0]:[232,0]:[233,0]:i<101426?i<101418?i<101338?[150,0]:[151,0]:[152,0]:i<101934?[234,2]:[236,0]:i<104352?i<103590?i<103080?i<102570?i<102315?[315,0]:[316,0]:[399,2]:[317,7]:[483,4]:i<105881?i<105371?i<104861?i<104606?[318,0]:[319,0]:[402,2]:[320,7]:[486,4]:i<106651?[237,0]:i<108596?i<107834?i<107467?i<106957?i<106801?[321,0]:[322,0]:[405,2]:i<107580?[323,0]:[407,0]:[489,4]:i<108760?i<108603?[324,0]:[408,0]:i<109002?[492,0]:[493,0]:i<118182?i<113596?i<111301?i<110537?[567,8]:i<111046?i<110791?[735,0]:[736,0]:[737,0]:[570,1]:i<115889?i<115124?i<114614?i<114106?[819,2]:[903,2]:[821,7]:[987,4]:i<117417?i<116907?i<116399?[822,2]:[906,2]:[824,7]:[990,4]:i<120819?i<120386?i<119711?i<119202?[573,5]:i<119457?[575,0]:[659,0]:i<120221?[741,2]:[743,0]:i<120712?i<120613?i<120611?[576,0]:[577,0]:[660,0]:i<120713?[744,0]:[745,0]:i<122779?i<122016?i<121728?i<121306?i<121074?[825,0]:[826,0]:i<121560?[909,0]:[910,0]:i<121777?[827,0]:[911,0]:i<122524?[993,2]:[995,0]:i<123708?i<123200?i<122946?[828,0]:[829,0]:[912,2]:[996,2]:i<125196?i<125096?i<124351?i<124313?i<124237?[662,0]:[663,0]:[664,0]:i<124846?i<124592?[746,0]:[747,0]:[748,0]:[749,0]:i<127488?i<126723?i<126214?i<125706?[830,2]:[914,2]:i<126469?[832,0]:[916,0]:[998,4]:i<128001?i<127723?i<127720?[833,0]:[834,0]:i<127977?[917,0]:[918,0]:i<128249?[1001,0]:[1002,0]:i<148599?i<144190?i<136942?i<132827?i<130534?i<129791?i<129282?i<128772?[1071,2]:[1155,2]:i<129536?[1073,0]:[1157,0]:i<130279?i<130024?[1239,0]:[1240,0]:[1241,0]:i<132062?i<131552?i<131042?[1074,2]:[1158,2]:[1076,7]:[1242,4]:i<134697?i<134224?i<133714?i<133296?i<133041?[1323,0]:[1324,0]:i<133459?[1407,0]:[1408,0]:[1325,7]:i<134443?i<134248?[1491,0]:[1492,0]:[1493,0]:i<136227?[1326,8]:i<136736?i<136482?[1494,0]:[1495,0]:[1496,0]:i<140762?i<139234?i<138469?i<137960?i<137450?[1077,2]:[1161,2]:i<138214?[1079,0]:[1163,0]:[1245,4]:i<140252?i<139742?[1080,2]:[1164,2]:[1248,2]:i<142660?i<142188?i<141678?i<141272?[1329,2]:i<141516?[1413,0]:[1414,0]:[1331,7]:i<142405?i<142245?[1497,0]:[1498,0]:[1499,0]:[1332,6]:i<144398?i<144260?i<144192?[1576,0]:[1577,0]:i<144355?[1578,0]:[1579,0]:i<147312?i<145782?i<145332?i<144822?i<144604?[1582,0]:[1666,0]:[1583,7]:i<145527?[1750,0]:[1751,0]:[1584,6]:i<147689?i<147388?[1834,0]:i<147636?[1835,0]:[1919,0]:i<148199?[1836,2]:i<148373?[1920,0]:[1921,0]:i<157134?i<153885?i<150924?i<150767?i<150107?i<149617?i<149107?[1082,2]:[1166,2]:i<149871?[1084,0]:[1168,0]:i<150617?[1250,2]:[1252,0]:i<150914?i<150905?[1085,0]:[1169,0]:[1254,0]:i<152717?i<151975?i<151878?i<151431?i<151179?[1334,0]:[1335,0]:i<151686?[1418,0]:[1419,0]:i<151910?[1336,0]:[1420,0]:i<152464?i<152230?[1502,0]:[1503,0]:[1504,0]:i<153375?i<152908?i<152726?[1337,0]:[1338,0]:i<153120?[1421,0]:[1422,0]:[1505,2]:i<154329?i<154325?i<154205?i<154019?[1255,0]:[1256,0]:[1257,0]:[1258,0]:i<156623?i<155858?i<155349?[1339,5]:i<155603?[1341,0]:[1425,0]:[1507,4]:i<156952?i<156749?[1342,0]:[1426,0]:[1510,0]:i<162418?i<160959?[1586,3]:i<162144?i<161847?i<161469?[1838,2]:i<161690?[1922,0]:[1923,0]:i<162100?[1840,0]:[1924,0]:i<162333?[1841,0]:[1842,0]:i<165373?i<164713?[1591,1]:i<165166?i<164911?[1594,0]:i<165158?[1678,0]:[1679,0]:[1762,0]:i<166005?i<165798?i<165792?i<165550?[1843,0]:[1844,0]:[1928,0]:i<166004?[1845,0]:[1929,0]:[1846,0];
			}

	}

	function Emitter_Flares() {

		var _2s = [[9.9, 9.46667], [19.8, 18.9333], [19.8, 9.46667], [39.6, 18.9333], [9.9, 18.9333], [29.7, 18.9333], [39.6, 37.8667]], _1, _2Srch, _2 = [], _3 = [], _5 = [], _8, _10=[], _11, _12, _13, _13i0, _13s0 = [], _14;
		this.pe = [{xe:0,Rc:1,Sc:1,renderStyleIndex:1}];
		this.name = "Flares";

		this.ud = function(Bd) {
			Bd.dd();
			Bd._13 = [
				[
					[0,0.0204988,0.0450217,0.0738911,0.107476,0.146204,0.190574,0.241172,0.298699,0.364,0.438111,0.522318,0.618249,0.727982,0.854172,1,1],
					[1,0.989961,0.961407,0.914303,0.849348,0.76822,0.673774,0.570084,0.462253,0.355951,0.256789,0.169699,0.0985013,0.0457442,0.0127831,0,0]
				]
			];
			Bd.jd = 100;
			Bd.Vc = 0;
		}

		this.Mb = function(vd) {
			vd.zb = 25;
			vd.Gb = 1;
			vd.Jb = 1;
		}

		this.Pb = function(Qb, Bd, vd) {
			vd.zb = 25;
		}

		this.fd = function(Bd, Xb) {
			Xb._ = 0.0;
			_1 = 0 + Bd.Ld.rand() * (1 - 0);
			_2Srch = this._2f(_1 * 62845);
			ctx.yb(_2, -268 + (_2Srch[0] % 70) * 9.9, 124 + Math.floor(_2Srch[0] / 70) * 9.46667, _2s[_2Srch[1]], Bd.Ld.rand);
			ctx.W(_3, _2[0], _2[1], 0);
			Xb._4 = [];
			ctx.c(Xb._4, Bd.Ab, _3);
			ctx.randv3gen(_5, 10, Bd.Ld.rand);
			Xb._6 = [];
			ctx.T(Xb._6, _5);
			Xb._7 = 0;
			_8 = 4 + Bd.Ld.rand() * (7 - 4);
			Xb._9 = _8;
			ctx.T(Xb.Ab, Xb._4);
		}

		this.gd = function(Bd, Xb) {
			Xb._ = 0.0;
			_1 = 0 + Bd.Ld.rand() * (1 - 0);
			_2Srch = this._2f(_1 * 62845);
			ctx.yb(_2, -268 + (_2Srch[0] % 70) * 9.9, 124 + Math.floor(_2Srch[0] / 70) * 9.46667, _2s[_2Srch[1]], Bd.Ld.rand);
			ctx.W(_3, _2[0], _2[1], 0);
			Xb._4 = [];
			ctx.c(Xb._4, Bd.Ab, _3);
			ctx.randv3gen(_5, 10, Bd.Ld.rand);
			Xb._6 = [];
			ctx.T(Xb._6, _5);
			Xb._7 = 0;
			_8 = 4 + Bd.Ld.rand() * (7 - 4);
			Xb._9 = _8;
			ctx.T(Xb.Ab, Xb._4);
		}

		this.qc = function(Qb, Bd, Xb) {
			Xb._ += Qb;
			ctx.T(_10, Xb._6);
			ctx.u(_10, _10, Qb);
			ctx.c(_10, _10, Xb._4);
			ctx.T(Xb._4, _10);
			ctx.T(Xb.Ab, Xb._4);
			_11 = 2;
			_12 = (Xb._ / _11);
			_13i0=(_12<0?0:(_12>1?1:_12));
			_13i0<0.2?ctx.V(_13s0,0,(_13i0-0)*75):ctx.V(_13s0,1,(_13i0-0.2)*18.75);
			_13 = Db.nb(Bd._13[0][_13s0[0]],_13s0[1]);
			_14 = (Xb._9 * _13);
			ctx.S(Xb.Pd,[0.5,0.5]);
			Xb.Md = Xb._7;
			ctx.V(Xb.Nd,_14,_14);
			ctx.T(Xb.gf,[1,1,1]);
			Xb.Od = 1;
			Xb.Qc = 0;
		}

		this.Cc = function(Bd, Xb, Wc) {
			_11 = 2;
			return Xb._ > _11;
		}

			this._2f = function(i) {
				return i<34763?i<30529?i<7443?i<7092?i<1276?i<612?i<17?[74,0]:i<253?i<35?[143,0]:[144,0]:i<357?[213,0]:[214,0]:i<1238?i<977?i<722?[283,0]:[284,0]:i<1004?[353,0]:[354,0]:[424,0]:i<3574?i<1537?i<1475?i<1373?[75,0]:[76,0]:i<1526?[77,0]:[78,0]:i<2556?i<2046?i<1792?[145,0]:[146,0]:[215,2]:i<3064?[147,2]:[217,2]:i<5613?i<4593?i<4084?[285,2]:i<4339?[355,0]:[356,0]:[287,1]:i<6086?i<6041?i<5793?[425,0]:[426,0]:[496,0]:i<6595?i<6341?[427,0]:[428,0]:i<6837?[497,0]:[498,0]:i<7441?i<7372?i<7153?[567,0]:[568,0]:[638,0]:[708,0]:i<22874?i<15581?i<10487?i<9008?i<7481?i<7465?[79,2]:[81,0]:i<8499?i<7989?[149,2]:[219,2]:i<8753?[151,0]:[221,0]:i<9469?i<9044?i<9009?[12,0]:[13,0]:i<9216?[82,0]:[83,0]:i<9978?i<9724?[152,0]:[153,0]:i<10233?[222,0]:[223,0]:i<13545?i<12017?[289,5]:i<13035?i<12525?[429,2]:[499,2]:[431,4]:i<14563?i<14054?i<13800?[292,0]:[293,0]:i<14309?[362,0]:[363,0]:i<15072?i<14818?[432,0]:[433,0]:i<15327?[502,0]:[503,0]:i<18810?i<16778?i<16341?i<15833?i<15685?[14,0]:[15,0]:[84,2]:i<16418?[16,0]:i<16671?[86,0]:[87,0]:[154,3]:[294,6]:i<27719?i<27365?i<25328?i<24403?i<23893?i<23384?[569,2]:i<23638?[639,0]:[640,0]:[571,4]:i<24890?i<24827?i<24573?[709,0]:[710,0]:i<24829?[779,0]:[780,0]:i<25145?[711,0]:[781,0]:i<26347?i<25838?[572,2]:i<26093?[642,0]:[643,0]:i<26856?i<26602?[712,0]:[713,0]:i<27111?[782,0]:[783,0]:i<27376?[851,0]:i<27519?[852,0]:[853,0]:i<30381?i<29379?i<28735?[574,1]:i<29132?i<28989?[576,0]:[577,0]:i<29364?[646,0]:[647,0]:i<30292?i<29886?i<29633?[714,0]:[715,0]:i<30140?[784,0]:[785,0]:[716,0]:i<30520?[854,0]:[855,0]:i<31927?i<31858?i<30557?i<30556?[88,0]:[89,0]:i<31527?i<31019?i<30811?[158,0]:[159,0]:[228,2]:i<31606?[160,0]:[230,0]:[231,0]:i<34449?i<33451?[298,5]:i<34218?i<33959?[438,2]:i<34131?[508,0]:[509,0]:i<34437?[440,0]:[510,0]:i<34737?i<34603?[301,0]:[371,0]:[441,0]:i<51085?i<37128?i<36685?i<35565?i<34787?[111,0]:i<35069?i<34860?[42,0]:[43,0]:i<35311?[112,0]:[113,0]:i<35673?i<35638?[181,0]:[251,0]:i<36181?[182,2]:i<36431?[252,0]:[253,0]:i<37055?i<36802?[322,0]:[323,0]:[393,0]:i<49211?i<45249?i<40658?i<39680?i<38156?i<37965?i<37457?i<37347?[44,0]:[45,0]:[114,2]:i<37966?[46,0]:[116,0]:[184,5]:i<39716?[117,0]:i<40150?i<39963?[187,0]:[188,0]:[257,2]:i<43215?i<42145?i<41637?i<41166?[324,2]:i<41383?[394,0]:[395,0]:[326,4]:i<42707?i<42413?i<42166?[464,0]:[465,0]:i<42453?[534,0]:[535,0]:[466,4]:i<44231?[327,1]:i<44739?[467,2]:[537,2]:i<46075?i<45956?i<45450?i<45394?[189,0]:[190,0]:i<45704?[259,0]:[260,0]:[261,0]:i<47761?i<47091?[329,1]:i<47398?i<47343?[331,0]:[332,0]:i<47652?[401,0]:[402,0]:i<48764?i<48269?[469,2]:i<48522?[539,0]:[540,0]:i<49082?i<49018?[471,0]:[472,0]:[541,0]:i<50955?i<50024?i<50019?i<49536?i<49459?i<49223?[604,0]:[605,0]:[675,0]:i<49790?[606,0]:[676,0]:[746,0]:i<50942?i<50532?[607,2]:i<50779?[677,0]:[678,0]:[747,0]:i<51078?i<51069?[609,0]:[610,0]:[679,0]:i<60214?i<51560?i<51094?[549,0]:i<51140?i<51095?[480,0]:[481,0]:i<51307?[550,0]:[551,0]:i<54818?i<53445?i<52051?i<51588?[685,0]:i<51606?i<51589?[754,0]:[824,0]:i<51801?[755,0]:[825,0]:i<52425?i<52219?[686,0]:[687,0]:[756,1]:i<53759?i<53450?[894,0]:i<53679?[895,0]:[965,0]:i<54763?i<54269?[896,2]:i<54509?[966,0]:[967,0]:i<54779?[1036,0]:[1037,0]:i<58578?i<56538?i<55518?i<55037?i<54839?[618,0]:[619,0]:i<55263?[688,0]:[689,0]:[620,1]:[758,3]:i<59524?i<59520?i<59088?[898,2]:i<59307?[968,0]:[969,0]:[1038,0]:i<60010?i<59779?[900,0]:[901,0]:i<60182?[970,0]:[971,0]:i<60712?i<60706?i<60269?i<60266?[482,0]:[483,0]:i<60523?[552,0]:[553,0]:[554,0]:i<62791?i<61930?i<61732?[622,1]:i<61819?[624,0]:[694,0]:i<62752?i<62431?i<62185?[762,0]:[763,0]:i<62674?[832,0]:[833,0]:[764,0]:[902,0];
			}

	}

	function Emitter_Sun_Glow() {

		var _1, _2 = [], _2i, _2s = [], _3 = [], _5, _7, _9, _11, _12, _13, _14, _14i0, _14s0 = [], _15;
		this.pe = [{xe:0,Rc:1,Sc:1,renderStyleIndex:2}];
		this.name = "Sun_Glow";

		this.ud = function(Bd) {
			Bd.dd();
			Bd._2 = [
				[[-150,-275],[-150,-275],[-150,-275]]
			];
			Bd._14 = [
				[
					[0,1,1],
					[1,0,0]
				]
			];
			Bd.jd = 100;
			Bd.Vc = 0;
		}

		this.Mb = function(vd) {
			vd.zb = 5;
			vd.Gb = 1;
			vd.Jb = 1;
		}

		this.Pb = function(Qb, Bd, vd) {
			vd.zb = 5;
		}

		this.fd = function(Bd, Xb) {
			Xb._ = 0.0;
			_1 = 0 + Bd.Ld.rand() * (1 - 0);
			_2i = Db.kb(_1);
			ctx.V(_2s,0,(_2i-0)*1);
			Db.lb(_2, Bd._2[_2s[0]], _2s[1]);
			ctx.W(_3, _2[0], _2[1], 0);
			Xb._4 = [];
			ctx.c(Xb._4, Bd.Ab, _3);
			_5 = 0 + Bd.Ld.rand() * (360 - 0);
			Xb._6 = _5;
			_7 = 1 + Bd.Ld.rand() * (2 - 1);
			Xb._8 = _7;
			_9 = -60 + Bd.Ld.rand() * (60 - -60);
			Xb._10 = _9;
			ctx.T(Xb.Ab, Xb._4);
		}

		this.gd = function(Bd, Xb) {
			Xb._ = 0.0;
			_1 = 0 + Bd.Ld.rand() * (1 - 0);
			_2i = Db.kb(_1);
			ctx.V(_2s,0,(_2i-0)*1);
			Db.lb(_2, Bd._2[_2s[0]], _2s[1]);
			ctx.W(_3, _2[0], _2[1], 0);
			Xb._4 = [];
			ctx.c(Xb._4, Bd.Ab, _3);
			_5 = 0 + Bd.Ld.rand() * (360 - 0);
			Xb._6 = _5;
			_7 = 1 + Bd.Ld.rand() * (2 - 1);
			Xb._8 = _7;
			_9 = -60 + Bd.Ld.rand() * (60 - -60);
			Xb._10 = _9;
			ctx.T(Xb.Ab, Xb._4);
		}

		this.qc = function(Qb, Bd, Xb) {
			Xb._ += Qb;
			_11 = Xb._6 + Qb * Xb._10;
			Xb._6 = _11;
			ctx.T(Xb.Ab, Xb._4);
			_12 = 200;
			_13 = (Xb._ / Xb._8);
			_14i0=(_13<0?0:(_13>1?1:_13));
			_14i0<0.5?ctx.V(_14s0,0,(_14i0-0)*2):ctx.V(_14s0,1,(_14i0-0.5)*2);
			_14 = Db.nb(Bd._14[0][_14s0[0]],_14s0[1]);
			_15 = (_12 * _14);
			ctx.S(Xb.Pd,[0.5,0.5]);
			Xb.Md = Xb._6;
			ctx.V(Xb.Nd,_15,_15);
			ctx.T(Xb.gf,[1,1,1]);
			Xb.Od = 0.05;
			Xb.Qc = 0;
		}

		this.Cc = function(Bd, Xb, Wc) {
			return Xb._ > Xb._8;
		}


	}

	this.qd = function(Ld) {
		Ld.Dd = 0.0333333;
		Ld.Ud = 10;
		Ld.rand = function() { return Math.random(); };
		Ld.pd(new Emitter_Leaves_Middle());
		Ld.pd(new Emitter_Leaves_LeftAndRight());
		Ld.pd(new Emitter_Flares());
		Ld.pd(new Emitter_Sun_Glow());
	}
		this.kb = function (v) { 			return (v < 0) ? 0 : ((v > 1) ? 1 : v); 		}

		this.lb = function (r, path, je) { 			var indexInt = Math.floor(je); 			var lerp = je - indexInt; 			ctx.Y(r, path[indexInt], path[indexInt + 1], lerp); 		}

		this.nb = function(funcValues, je) { 			var indexInt = Math.floor(je); 			var nextInt = indexInt + 1; 			return ctx.X(funcValues[indexInt], funcValues[nextInt], je - indexInt); 		}

}